{
    "openapi":"3.0.1",
    "info":{
        "title":"Primavera Administration REST API",
        "description":"REST API for the Primavera Administration Application.",
        "version":"2026.06.16",
        "x-summary":"REST API for the Primavera Administration Application."
    },
    "servers":[
        {
            "url":"/cloudapi/restapi"
        }
    ],
    "tags":[
        {
            "name":"Background Jobs",
            "description":"The operations from the Background Jobs category."
        },
        {
            "name":"Background Jobs (v3)",
            "description":"The operations from the Background Jobs (v3) category."
        },
        {
            "name":"OAuth2",
            "description":"The operations from the OAuth2 category."
        },
        {
            "name":"Roles",
            "description":"The operations from the Roles category."
        },
        {
            "name":"Roles (v3)",
            "description":"The operations from the Roles (v3) category."
        },
        {
            "name":"User Audit Events",
            "description":"The operations from the User Audit Events category."
        },
        {
            "name":"User Audit Events (v3)",
            "description":"The operations from the User Audit Events (v3) category."
        },
        {
            "name":"User Management",
            "description":"This operation enables you to view, create, and provision users and edit user attributes. This service also allows other common actions like enabling, disabling, and unlocking a user record."
        },
        {
            "name":"User Management (v2)",
            "description":"The operations from the User Management (v2) category."
        },
        {
            "name":"User Management (v3)",
            "description":"The operations from the User Management (v3) category."
        }
    ],
    "paths":{
        "/bgjobs/{bgJobName}":{
            "get":{
                "tags":[
                    "Background Jobs"
                ],
                "summary":"Get Job Details",
                "description":"This end point returns background job details. It includes the last run date, start time of job, end time of completed job, job status, logs if job is processed, and runtime user \n\nExample request: GET /cloudapi/restapi/bgjobs/PVD",
                "operationId":"/bgjobs/{bgJobName}_getBGJob",
                "parameters":[
                    {
                        "name":"bgJobName",
                        "in":"path",
                        "description":"Background job name for which the status is being requested",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"PVD"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/BackgroundJobService"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"An invalid job name was specified. Please recheck the input. Job name can only be pvd, datasync or bidder"
                    }
                },
                "x-internal-id":"bgjobs-{bgJobName}-get",
                "x-filename-id":"bgjobs-bgjobname-get"
            },
            "post":{
                "tags":[
                    "Background Jobs"
                ],
                "summary":"Trigger a background job",
                "description":"This end point runs a background job. Current status and job details would be returned back as a response. Status can be Running, Completed, or Failed.\n\nExample request: POST /cloudapi/restapi/bgjobs/PVD",
                "operationId":"/bgjobs/{bgJobName}_runBGJob",
                "parameters":[
                    {
                        "name":"bgJobName",
                        "in":"path",
                        "description":"Name of the background job to be run",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"PVD"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/BackgroundJobService"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"An invalid job name was specified. Please recheck the input. Job name can only be pvd, datasync or bidder"
                    },
                    "500":{
                        "description":"An internal error occurred. Inspect the log for more information"
                    }
                },
                "x-internal-id":"bgjobs-{bgJobName}-post",
                "x-filename-id":"bgjobs-bgjobname-post"
            }
        },
        "/v3/bgjobs/{bgJobName}":{
            "get":{
                "tags":[
                    "Background Jobs (v3)"
                ],
                "summary":"Get Job Details",
                "description":"This end point returns background job details. It includes the last run date, start time of job, end time of completed job, job status, logs if job is processed, and runtime user \n\nExample request: GET /cloudapi/restapi/v3/bgjobs/PVD",
                "operationId":"/v3/bgjobs/{bgJobName}_getBGJob_1",
                "parameters":[
                    {
                        "name":"bgJobName",
                        "in":"path",
                        "description":"Background job name for which the status is being requested",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"PVD"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/BackgroundJobService"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"An invalid job name was specified. Please recheck the input. Job name can only be pvd, datasync or bidder"
                    }
                },
                "x-internal-id":"v3-bgjobs-{bgJobName}-get",
                "x-filename-id":"v3-bgjobs-bgjobname-get"
            },
            "post":{
                "tags":[
                    "Background Jobs (v3)"
                ],
                "summary":"Trigger a background job",
                "description":"This end point runs a background job. Current status and job details would be returned back as a response. Status can be Running, Completed, or Failed.\n\nExample request: POST /cloudapi/restapi/v3/bgjobs/PVD",
                "operationId":"/v3/bgjobs/{bgJobName}_runBGJob_1",
                "parameters":[
                    {
                        "name":"bgJobName",
                        "in":"path",
                        "description":"Name of the background job to be run",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"PVD"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/BackgroundJobService"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"An invalid job name was specified. Please recheck the input. Job name can only be pvd, datasync or bidder"
                    },
                    "500":{
                        "description":"An internal error occurred. Inspect the log for more information"
                    }
                },
                "x-internal-id":"v3-bgjobs-{bgJobName}-post",
                "x-filename-id":"v3-bgjobs-bgjobname-post"
            }
        },
        "/roles":{
            "get":{
                "tags":[
                    "Roles"
                ],
                "summary":"Get Application Roles",
                "description":"This end point returns application roles. It includes roles of all the products available for the respective environment.",
                "operationId":"/roles_getAppRoles",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/RoleRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"roles-get",
                "x-filename-id":"roles-get"
            }
        },
        "/v3/roles":{
            "get":{
                "tags":[
                    "Roles (v3)"
                ],
                "summary":"Get Application Roles",
                "description":"This end point returns application roles. It includes roles of all the products available for the respective environment.",
                "operationId":"/v3/roles_getAppRoles_1",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/RoleRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"v3-roles-get",
                "x-filename-id":"v3-roles-get"
            }
        },
        "/audits":{
            "get":{
                "tags":[
                    "User Audit Events"
                ],
                "summary":"Get All Users Audit Events",
                "description":"This end point returns all users audit events.",
                "operationId":"/audits_getAllAuditEvents",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"audits-get",
                "x-filename-id":"audits-get"
            }
        },
        "/audits/page/{page}/count/{size}":{
            "get":{
                "tags":[
                    "User Audit Events"
                ],
                "summary":"Get Audit Events On Pagination Filter",
                "description":"This end point returns all users audit events on pagination filter.\n\nExample request: GET /cloudapi/restapi/audits/page/1/count/25",
                "operationId":"/audits/page/{page}/count/{size}_getAuditEventByPage",
                "parameters":[
                    {
                        "name":"page",
                        "in":"path",
                        "description":"Page number for paginated audit events.",
                        "required":true,
                        "schema":{
                            "type":"integer",
                            "format":"int32"
                        },
                        "example":1
                    },
                    {
                        "name":"size",
                        "in":"path",
                        "description":"Number of audit events to return in the page.",
                        "required":true,
                        "schema":{
                            "type":"integer",
                            "format":"int32"
                        },
                        "example":25
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"audits-page-{page}-count-{size}-get",
                "x-filename-id":"audits-page-page-count-size-get"
            }
        },
        "/audits/from/{startDate}/to/{endDate}":{
            "get":{
                "tags":[
                    "User Audit Events"
                ],
                "summary":"Get Audit Events On Date Filter",
                "description":"This end point returns all users audit events on date filter.\n\nExample request: GET /cloudapi/restapi/audits/from/2026-05-01/to/2026-05-31",
                "operationId":"/audits/from/{startDate}/to/{endDate}_getAuditEventsForDateRange",
                "parameters":[
                    {
                        "name":"startDate",
                        "in":"path",
                        "description":"Start date for the audit event date range.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"2026-05-01"
                    },
                    {
                        "name":"endDate",
                        "in":"path",
                        "description":"End date for the audit event date range.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"2026-05-31"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"audits-from-{startDate}-to-{endDate}-get",
                "x-filename-id":"audits-startdate-enddate-get"
            }
        },
        "/audits/userEmail/{grantor}":{
            "get":{
                "tags":[
                    "User Audit Events"
                ],
                "summary":"Get Users Specific Audit Events",
                "description":"This end point returns specific users audit events.\n\nExample request: GET /cloudapi/restapi/audits/userEmail/jane.smith@example.com",
                "operationId":"/audits/userEmail/{grantor}_getAuditUserEvents",
                "parameters":[
                    {
                        "name":"grantor",
                        "in":"path",
                        "description":"Email address of the user whose audit events should be returned.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"jane.smith@example.com"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"audits-userEmail-{grantor}-get",
                "x-filename-id":"audits-useremail-grantor-get"
            }
        },
        "/v3/audits":{
            "get":{
                "tags":[
                    "User Audit Events (v3)"
                ],
                "summary":"Get All Users Audit Events",
                "description":"This end point returns all users audit events.",
                "operationId":"/v3/audits_getAllAuditEvents_1",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"v3-audits-get",
                "x-filename-id":"v3-audits-get"
            }
        },
        "/v3/audits/page/{page}/count/{size}":{
            "get":{
                "tags":[
                    "User Audit Events (v3)"
                ],
                "summary":"Get Audit Events On Pagination Filter",
                "description":"This end point returns all users audit events on pagination filter.\n\nExample request: GET /cloudapi/restapi/v3/audits/page/1/count/25",
                "operationId":"/v3/audits/page/{page}/count/{size}_getAuditEventByPage_1",
                "parameters":[
                    {
                        "name":"page",
                        "in":"path",
                        "description":"Page number for paginated audit events.",
                        "required":true,
                        "schema":{
                            "type":"integer",
                            "format":"int32"
                        },
                        "example":1
                    },
                    {
                        "name":"size",
                        "in":"path",
                        "description":"Number of audit events to return in the page.",
                        "required":true,
                        "schema":{
                            "type":"integer",
                            "format":"int32"
                        },
                        "example":25
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"v3-audits-page-{page}-count-{size}-get",
                "x-filename-id":"v3-audits-page-page-count-size-get"
            }
        },
        "/v3/audits/from/{startDate}/to/{endDate}":{
            "get":{
                "tags":[
                    "User Audit Events (v3)"
                ],
                "summary":"Get Audit Events On Date Filter",
                "description":"This end point returns all users audit events on date filter.\n\nExample request: GET /cloudapi/restapi/v3/audits/from/2026-05-01/to/2026-05-31",
                "operationId":"/v3/audits/from/{startDate}/to/{endDate}_getAuditEventsForDateRange_1",
                "parameters":[
                    {
                        "name":"startDate",
                        "in":"path",
                        "description":"Start date for the audit event date range.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"2026-05-01"
                    },
                    {
                        "name":"endDate",
                        "in":"path",
                        "description":"End date for the audit event date range.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"2026-05-31"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"v3-audits-from-{startDate}-to-{endDate}-get",
                "x-filename-id":"v3-audits-startdate-enddate-get"
            }
        },
        "/v3/audits/userEmail/{grantor}":{
            "get":{
                "tags":[
                    "User Audit Events (v3)"
                ],
                "summary":"Get Users Specific Audit Events",
                "description":"This end point returns specific users audit events.\n\nExample request: GET /cloudapi/restapi/v3/audits/userEmail/jane.smith@example.com",
                "operationId":"/v3/audits/userEmail/{grantor}_getAuditUserEvents_1",
                "parameters":[
                    {
                        "name":"grantor",
                        "in":"path",
                        "description":"Email address of the user whose audit events should be returned.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"jane.smith@example.com"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserAuditEventRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please re-check the input."
                    }
                },
                "x-internal-id":"v3-audits-userEmail-{grantor}-get",
                "x-filename-id":"v3-audits-useremail-grantor-get"
            }
        },
        "/user/change-lock":{
            "put":{
                "tags":[
                    "User Management"
                ],
                "summary":"Unlock Users",
                "description":"This operation unlocks a set of locked user accounts.",
                "operationId":"/user/change-lock_changeLockStatus",
                "requestBody":{
                    "description":"Array of user objects whose locked accounts should be unlocked.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Unlock_Users_Request":{
                                    "summary":"Unlock Users",
                                    "description":"Payload containing locked users to unlock.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "locked":false
                                        },
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "locked":false
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-change-lock-put",
                "x-filename-id":"user-change-lock-put"
            }
        },
        "/user/change-status":{
            "put":{
                "tags":[
                    "User Management"
                ],
                "summary":"Enable/Disable users",
                "description":"This operation enables or disables a set of users depending on the status of the users. If the user status input is the same as the user status in the database, no change is made.",
                "operationId":"/user/change-status_changeStatus",
                "requestBody":{
                    "description":"Array of user objects whose disabled status should be updated.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Enable_Users":{
                                    "summary":"Enable users",
                                    "description":"Payload containing currently disabled users to enable.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "disabled":true
                                        }
                                    ]
                                },
                                "Disable_Users":{
                                    "summary":"Disable users",
                                    "description":"Payload containing currently enabled users to disable.",
                                    "value":[
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "disabled":false
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-change-status-put",
                "x-filename-id":"user-change-status-put"
            }
        },
        "/user/manual-reset-pwd/{isEmailPasswd}":{
            "put":{
                "tags":[
                    "User Management"
                ],
                "summary":"Reset Users passwords (Known Value)",
                "description":"This operation resets the password for a set of users. The password for each user is set to the password string supplied in the user object. The operation can also notify the user regarding the password reset if required. 'changePwdAtNextLogin' is a read only field and always set to false.\n\nExample request: PUT /cloudapi/restapi/user/manual-reset-pwd/true",
                "operationId":"/user/manual-reset-pwd/{isEmailPasswd}_changeUserPwd",
                "parameters":[
                    {
                        "name":"isEmailPasswd",
                        "in":"path",
                        "description":"Controls whether an email notification should be triggered to each user regarding password-reset operation.",
                        "required":true,
                        "schema":{
                            "type":"boolean"
                        },
                        "example":true
                    }
                ],
                "requestBody":{
                    "description":"Array of user objects whose passwords to be reset",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Reset_Single_User_Password_Known_Value":{
                                    "summary":"Reset one user password with a known value",
                                    "description":"Payload containing one user key, login ID, and password value for manual password reset.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "password":"TempPassw0rd!"
                                        }
                                    ]
                                },
                                "Reset_Multiple_User_Passwords_Known_Value":{
                                    "summary":"Reset multiple user passwords with known values",
                                    "description":"Payload containing user keys, login IDs, and password values for manual password reset.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "password":"TempPassw0rd!"
                                        },
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "password":"TempPassw0rd!"
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"user-manual-reset-pwd-{isEmailPasswd}-put",
                "x-filename-id":"user-manual-reset-pwd-isemailpasswd-put"
            }
        },
        "/user/companies/add-list":{
            "post":{
                "tags":[
                    "User Management"
                ],
                "summary":"Create/Update Company",
                "description":"This operation enables you to create and modify Company records. The operation creates a company if a matching company does not exist in the system or modifies the company if a match is found. Any new roles provided under the roles attribute are provisioned for the company by the operation. If successful, this operation returns a company data store containing processed records and status information.",
                "operationId":"/user/companies/add-list_createObjects",
                "requestBody":{
                    "description":"Data store containing companies to create, modify, or delete.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "$ref":"#/components/schemas/CompanyDataStore"
                            },
                            "examples":{
                                "Create_Company":{
                                    "summary":"Create company",
                                    "description":"Payload containing a company to create.",
                                    "value":{
                                        "added":[
                                            {
                                                "associations":[
                                                    "ExamplePrimaveraUnifierProduction"
                                                ],
                                                "name":"Example Company",
                                                "displayName":"Example Company"
                                            }
                                        ],
                                        "modified":[
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                },
                                "Modify_Company":{
                                    "summary":"Modify company",
                                    "description":"Payload containing an existing company to modify.",
                                    "value":{
                                        "added":[
                                        ],
                                        "modified":[
                                            {
                                                "id":"41",
                                                "associations":[
                                                    "ExamplePrimaveraUnifierProduction"
                                                ],
                                                "name":"Updated Company",
                                                "displayName":"Updated Company"
                                            }
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/CompanyDataStore"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-companies-add-list-post",
                "x-filename-id":"user-companies-add-list-post"
            }
        },
        "/user":{
            "get":{
                "tags":[
                    "User Management"
                ],
                "summary":"Get all Users",
                "description":"This operation fetches all users. All attributes and assigned roles are returned for each user.",
                "operationId":"/user_getAllUsers",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"user-get",
                "x-filename-id":"user-get"
            },
            "post":{
                "tags":[
                    "User Management"
                ],
                "summary":"Create/Update users",
                "description":"This operation enables you to create and modify users records. The operation creates a user if a matching user does not exist in the system or modifies the user if a match is found. The primary key for the user object is loginId. Any new roles provided under the roles attribute are provisioned for the user by the operation. If the request data does not include roles assigned to the user in the existing database, those role assignments will be removed. If successful, this operation returns an accepted status (202) with a location header pointing to a jobId status. The operation is complete when the jobId status returns OK (200). The previous create user operation must complete before another create user operation is allowed.",
                "operationId":"/user_createObjects_1",
                "requestBody":{
                    "description":"Data store containing users to create, modify, or delete.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "$ref":"#/components/schemas/UserDataStore"
                            },
                            "examples":{
                                "Create_User":{
                                    "summary":"Create user",
                                    "description":"Payload containing a user to create.",
                                    "value":{
                                        "added":[
                                            {
                                                "roles":[
                                                    {
                                                        "id":"8ab246a1c2121333f8586afdc064f6562",
                                                        "displayName":"ExamplePrimaveraP6Production",
                                                        "name":"ExamplePrimaveraP6Production"
                                                    },
                                                    {
                                                        "id":"8058e086c8123d4a4ebae6c0e789e3c00c",
                                                        "displayName":"ExamplePrimaveraUnifierProduction",
                                                        "name":"ExamplePrimaveraUnifierProduction"
                                                    }
                                                ],
                                                "lastName":"Smith",
                                                "firstName":"Jane",
                                                "emailAddress":"jane.smith@example.com",
                                                "loginId":"jane.smith",
                                                "organization":{
                                                    "name":"Example Company"
                                                }
                                            }
                                        ],
                                        "modified":[
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                },
                                "Modify_User":{
                                    "summary":"Modify user",
                                    "description":"Payload containing an existing user to modify.",
                                    "value":{
                                        "added":[
                                        ],
                                        "modified":[
                                            {
                                                "roles":[
                                                    {
                                                        "id":"8ab246a1c2121333f8586afdc064f6562",
                                                        "displayName":"ExamplePrimaveraP6Production",
                                                        "name":"ExamplePrimaveraP6Production"
                                                    }
                                                ],
                                                "lastName":"Doe",
                                                "firstName":"John",
                                                "emailAddress":"john.doe@example.com",
                                                "loginId":"john.doe",
                                                "organization":{
                                                    "name":"Example Company"
                                                },
                                                "id":"c8617ccb81aa481b174bb7b48debc38a"
                                            }
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "202":{
                        "description":"Create/Modify Users request has been accepted and currently in progress.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"integer",
                                    "format":"int64"
                                }
                            }
                        }
                    },
                    "409":{
                        "description":"Another create or modify users job is already running for this session."
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-post",
                "x-filename-id":"user-post"
            }
        },
        "/user/status/{jobId}/draft":{
            "get":{
                "tags":[
                    "User Management"
                ],
                "summary":"Export a Job's failed users",
                "description":"This operation exports to a CSV file a list of all users for which a given create or modify job {jobId} failed.\n\nExample request: GET /cloudapi/restapi/user/status/12345/draft",
                "operationId":"/user/status/{jobId}/draft_exportFailedUsersInJob",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id corresponding to which failed users in creation/modification operation are requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/octet-stream":{
                                "schema":{
                                    "type":"string",
                                    "format":"binary"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-status-{jobId}-draft-get",
                "x-filename-id":"user-status-jobid-draft-get"
            }
        },
        "/user/status/{jobId}/log":{
            "get":{
                "tags":[
                    "User Management"
                ],
                "summary":"Export a Job's log",
                "description":"This operation exports a TXT file containing a summary of actions completed for a given job {jobId}.\n\nExample request: GET /cloudapi/restapi/user/status/12345/log",
                "operationId":"/user/status/{jobId}/log_exportJobLog",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id corresponding to a User Create/Modify operation for which the logs are requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/octet-stream":{
                                "schema":{
                                    "type":"string",
                                    "format":"binary"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-status-{jobId}-log-get",
                "x-filename-id":"user-status-jobid-log-get"
            }
        },
        "/user/status/{jobId}":{
            "get":{
                "tags":[
                    "User Management"
                ],
                "summary":"Get Job status",
                "description":"This operation reveals the status corresponding to the job {jobId}. If the job is complete, the operation returns OK (200), otherwise the operation returns ACCEPTED (202) with the location header in the response.\n\nExample request: GET /cloudapi/restapi/user/status/12345",
                "operationId":"/user/status/{jobId}_getCreateUsersStatus",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id for which the status is being requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"Create/Modify Users job has been successfully executed.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserDataStore"
                                }
                            }
                        }
                    },
                    "202":{
                        "description":"This Create/Modify Users job is currently in progress.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserDataStore"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-status-{jobId}-get",
                "x-filename-id":"user-status-jobid-get"
            }
        },
        "/user/{userId}":{
            "get":{
                "tags":[
                    "User Management"
                ],
                "summary":"Get User",
                "description":"This operation fetches a user. All attributes and assigned roles for the user are returned.\n\nExample request: GET /cloudapi/restapi/user/c8617ccb81aa481b174bb7b48debc38a\nExample request: GET /cloudapi/restapi/user/jane.smith",
                "operationId":"/user/{userId}_getUser",
                "parameters":[
                    {
                        "name":"userId",
                        "in":"path",
                        "description":"LoginId of the user being requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "examples":{
                            "User_Id":{
                                "summary":"User ID",
                                "description":"Internal user identifier.",
                                "value":"c8617ccb81aa481b174bb7b48debc38a"
                            },
                            "Login_Id":{
                                "summary":"Login ID",
                                "description":"User login identifier.",
                                "value":"jane.smith"
                            }
                        }
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"user-{userId}-get",
                "x-filename-id":"user-userid-get"
            }
        },
        "/user/{userId}/auto-reset-pwd":{
            "put":{
                "tags":[
                    "User Management"
                ],
                "summary":"Reset a User password (Random Value)",
                "description":"This operation generates a random string and writes it to the password field for the supplied {userId}. The user is notified when the operation completes successfully.\n\nExample request: PUT /cloudapi/restapi/user/c8617ccb81aa481b174bb7b48debc38a/auto-reset-pwd",
                "operationId":"/user/{userId}/auto-reset-pwd_resetPwdAndNotify",
                "parameters":[
                    {
                        "name":"userId",
                        "in":"path",
                        "description":"LoginId of the user for whom the password needs to be automatically reset.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"c8617ccb81aa481b174bb7b48debc38a"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "text/plain":{
                                "schema":{
                                    "type":"string"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-{userId}-auto-reset-pwd-put",
                "x-filename-id":"user-userid-auto-reset-pwd-put"
            }
        },
        "/user/auto-reset-pwd":{
            "put":{
                "tags":[
                    "User Management"
                ],
                "summary":"Reset Users passwords (Random Value)",
                "description":"This operation generates a random string and writes it to the password field for each of a list of users. The users are notified when the operation completes successfully.",
                "operationId":"/user/auto-reset-pwd_resetPwdAndNotify_1",
                "requestBody":{
                    "description":"Array of User Id strings whose passwords to be automatically reset.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "type":"array",
                                "items":{
                                    "type":"string"
                                }
                            },
                            "examples":{
                                "Reset_Single_User_Password":{
                                    "summary":"Reset one user password",
                                    "description":"Payload containing one user key whose password should be reset to a random value.",
                                    "value":[
                                        "c8617ccb81aa481b174bb7b48debc38a"
                                    ]
                                },
                                "Reset_Multiple_User_Passwords":{
                                    "summary":"Reset multiple user passwords",
                                    "description":"Payload containing user keys whose passwords should be reset to random values.",
                                    "value":[
                                        "c8617ccb81aa481b174bb7b48debc38a",
                                        "d9f2c4a6c8b84793a3f5d6e7a8b9012a"
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"user-auto-reset-pwd-put",
                "x-filename-id":"user-auto-reset-pwd-put"
            }
        },
        "/v2/user/change-status":{
            "put":{
                "tags":[
                    "User Management (v2)"
                ],
                "summary":"Enable/Disable users",
                "description":"This operation enables or disables a set of users depending on the status of the users. User status is enabled when disabled property in the request body is set to false(disabled=false) and vice versa.",
                "operationId":"/v2/user/change-status_changeStatus_1",
                "requestBody":{
                    "description":"Array of user objects whose disabled status should be updated.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Enable_Users":{
                                    "summary":"Enable users",
                                    "description":"Payload containing users whose desired disabled state is false.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "disabled":false
                                        }
                                    ]
                                },
                                "Disable_Users":{
                                    "summary":"Disable users",
                                    "description":"Payload containing users whose desired disabled state is true.",
                                    "value":[
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "disabled":true
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v2-user-change-status-put",
                "x-filename-id":"v2-user-change-status-put"
            }
        },
        "/v3/user/change-lock":{
            "put":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Unlock Users",
                "description":"This operation unlocks a set of locked user accounts.",
                "operationId":"/v3/user/change-lock_changeLockStatus_1",
                "requestBody":{
                    "description":"Array of user objects whose locked accounts should be unlocked.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Unlock_Users_Request":{
                                    "summary":"Unlock Users",
                                    "description":"Payload containing locked users to unlock.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "locked":false
                                        },
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "locked":false
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-change-lock-put",
                "x-filename-id":"v3-user-change-lock-put"
            }
        },
        "/v3/user/change-status":{
            "put":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Enable/Disable users",
                "description":"This operation enables or disables a set of users depending on the status of the users. User status is enabled when disabled property in the request body is set to false(disabled=false) and vice versa.",
                "operationId":"/v3/user/change-status_changeStatus_2",
                "requestBody":{
                    "description":"Array of user objects whose disabled status should be updated.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Enable_Users":{
                                    "summary":"Enable users",
                                    "description":"Payload containing users whose desired disabled state is false.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "disabled":false
                                        }
                                    ]
                                },
                                "Disable_Users":{
                                    "summary":"Disable users",
                                    "description":"Payload containing users whose desired disabled state is true.",
                                    "value":[
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "disabled":true
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserOperationStatusMap"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-change-status-put",
                "x-filename-id":"v3-user-change-status-put"
            }
        },
        "/v3/user/manual-reset-pwd/{isEmailPasswd}":{
            "put":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Reset Users passwords (Known Value)",
                "description":"This operation resets the password for a set of users. The password for each user is set to the password string supplied in the user object. The operation can also notify the user regarding the password reset if required. 'changePwdAtNextLogin' is a read only field and always set to false.\n\nExample request: PUT /cloudapi/restapi/v3/user/manual-reset-pwd/true",
                "operationId":"/v3/user/manual-reset-pwd/{isEmailPasswd}_changeUserPwd_1",
                "parameters":[
                    {
                        "name":"isEmailPasswd",
                        "in":"path",
                        "description":"Controls whether an email notification should be triggered to each user regarding password-reset operation.",
                        "required":true,
                        "schema":{
                            "type":"boolean"
                        },
                        "example":true
                    }
                ],
                "requestBody":{
                    "description":"Array of user objects whose passwords to be reset",
                    "content":{
                        "application/json":{
                            "schema":{
                                "title":"List<UserRO>",
                                "type":"array",
                                "items":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            },
                            "examples":{
                                "Reset_Single_User_Password_Known_Value":{
                                    "summary":"Reset one user password with a known value",
                                    "description":"Payload containing one user key, login ID, and password value for manual password reset.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "password":"TempPassw0rd!"
                                        }
                                    ]
                                },
                                "Reset_Multiple_User_Passwords_Known_Value":{
                                    "summary":"Reset multiple user passwords with known values",
                                    "description":"Payload containing user keys, login IDs, and password values for manual password reset.",
                                    "value":[
                                        {
                                            "id":"c8617ccb81aa481b174bb7b48debc38a",
                                            "loginId":"jane.smith",
                                            "password":"TempPassw0rd!"
                                        },
                                        {
                                            "id":"d9f2c4a6c8b84793a3f5d6e7a8b9012a",
                                            "loginId":"john.doe",
                                            "password":"TempPassw0rd!"
                                        }
                                    ]
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"v3-user-manual-reset-pwd-{isEmailPasswd}-put",
                "x-filename-id":"v3-user-manual-reset-pwd-isemailpasswd-put"
            }
        },
        "/v3/user/companies/add-list":{
            "post":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Create/Update Company",
                "description":"This operation enables you to create and modify Company records. The operation creates a company if a matching company does not exist in the system or modifies the company if a match is found. Any new roles provided under the roles attribute are provisioned for the company by the operation. If successful, this operation returns a company data store containing processed records and status information.",
                "operationId":"/v3/user/companies/add-list_createObjects_2",
                "requestBody":{
                    "description":"Data store containing companies to create, modify, or delete.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "$ref":"#/components/schemas/CompanyDataStore"
                            },
                            "examples":{
                                "Create_Company":{
                                    "summary":"Create company",
                                    "description":"Payload containing a company to create.",
                                    "value":{
                                        "added":[
                                            {
                                                "associations":[
                                                    "ExamplePrimaveraUnifierProduction"
                                                ],
                                                "name":"Example Company",
                                                "displayName":"Example Company"
                                            }
                                        ],
                                        "modified":[
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                },
                                "Modify_Company":{
                                    "summary":"Modify company",
                                    "description":"Payload containing an existing company to modify.",
                                    "value":{
                                        "added":[
                                        ],
                                        "modified":[
                                            {
                                                "id":"41",
                                                "associations":[
                                                    "ExamplePrimaveraUnifierProduction"
                                                ],
                                                "name":"Updated Company",
                                                "displayName":"Updated Company"
                                            }
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/CompanyDataStore"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-companies-add-list-post",
                "x-filename-id":"v3-user-companies-add-list-post"
            }
        },
        "/v3/user":{
            "get":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Get all Users",
                "description":"This operation fetches all users. All attributes and assigned roles are returned for each user.",
                "operationId":"/v3/user_getAllUsers_1",
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"array",
                                    "items":{
                                        "$ref":"#/components/schemas/UserRO"
                                    }
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"v3-user-get",
                "x-filename-id":"v3-user-get"
            },
            "post":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Create/Update users",
                "description":"This operation enables you to create and modify users records. The operation creates a user if a matching user does not exist in the system or modifies the user if a match is found. The primary key for the user object is loginId. Any new roles provided under the roles attribute are provisioned for the user by the operation. If the request data does not include roles assigned to the user in the existing database, those role assignments will be removed. If successful, this operation returns an accepted status (202) with a location header pointing to a jobId status. The operation is complete when the jobId status returns OK (200). The previous create user operation must complete before another create user operation is allowed.",
                "operationId":"/v3/user_createObjects_3",
                "requestBody":{
                    "description":"Data store containing users to create, modify, or delete.",
                    "content":{
                        "application/json":{
                            "schema":{
                                "$ref":"#/components/schemas/UserDataStore"
                            },
                            "examples":{
                                "Create_User":{
                                    "summary":"Create user",
                                    "description":"Payload containing a user to create.",
                                    "value":{
                                        "added":[
                                            {
                                                "roles":[
                                                    {
                                                        "id":"8ab246a1c2121333f8586afdc064f6562",
                                                        "displayName":"ExamplePrimaveraP6Production",
                                                        "name":"ExamplePrimaveraP6Production"
                                                    },
                                                    {
                                                        "id":"8058e086c8123d4a4ebae6c0e789e3c00c",
                                                        "displayName":"ExamplePrimaveraUnifierProduction",
                                                        "name":"ExamplePrimaveraUnifierProduction"
                                                    }
                                                ],
                                                "lastName":"Smith",
                                                "firstName":"Jane",
                                                "emailAddress":"jane.smith@example.com",
                                                "loginId":"jane.smith",
                                                "organization":{
                                                    "name":"Example Company"
                                                }
                                            }
                                        ],
                                        "modified":[
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                },
                                "Modify_User":{
                                    "summary":"Modify user",
                                    "description":"Payload containing an existing user to modify.",
                                    "value":{
                                        "added":[
                                        ],
                                        "modified":[
                                            {
                                                "roles":[
                                                    {
                                                        "id":"8ab246a1c2121333f8586afdc064f6562",
                                                        "displayName":"ExamplePrimaveraP6Production",
                                                        "name":"ExamplePrimaveraP6Production"
                                                    }
                                                ],
                                                "lastName":"Doe",
                                                "firstName":"John",
                                                "emailAddress":"john.doe@example.com",
                                                "loginId":"john.doe",
                                                "organization":{
                                                    "name":"Example Company"
                                                },
                                                "id":"c8617ccb81aa481b174bb7b48debc38a"
                                            }
                                        ],
                                        "deleted":[
                                        ]
                                    }
                                }
                            }
                        }
                    },
                    "required":true
                },
                "responses":{
                    "202":{
                        "description":"Create/Modify Users request has been accepted and currently in progress.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "type":"integer",
                                    "format":"int64"
                                }
                            }
                        }
                    },
                    "409":{
                        "description":"Another create or modify users job is already running for this session."
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-post",
                "x-filename-id":"v3-user-post"
            }
        },
        "/v3/user/status/{jobId}/draft":{
            "get":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Export a Job's failed users",
                "description":"This operation exports to a CSV file a list of all users for which a given create or modify job {jobId} failed.\n\nExample request: GET /cloudapi/restapi/v3/user/status/12345/draft",
                "operationId":"/v3/user/status/{jobId}/draft_exportFailedUsersInJob_1",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id corresponding to which failed users in creation/modification operation are requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/octet-stream":{
                                "schema":{
                                    "type":"string",
                                    "format":"binary"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-status-{jobId}-draft-get",
                "x-filename-id":"v3-user-status-jobid-draft-get"
            }
        },
        "/v3/user/status/{jobId}/log":{
            "get":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Export a Job's log",
                "description":"This operation exports a TXT file containing a summary of actions completed for a given job {jobId}.\n\nExample request: GET /cloudapi/restapi/v3/user/status/12345/log",
                "operationId":"/v3/user/status/{jobId}/log_exportJobLog_1",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id corresponding to a User Create/Modify operation for which the logs are requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/octet-stream":{
                                "schema":{
                                    "type":"string",
                                    "format":"binary"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-status-{jobId}-log-get",
                "x-filename-id":"v3-user-status-jobid-log-get"
            }
        },
        "/v3/user/status/{jobId}":{
            "get":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Get Job status",
                "description":"This operation reveals the status corresponding to the job {jobId}. If the job is complete, the operation returns OK (200), otherwise the operation returns ACCEPTED (202) with the location header in the response.\n\nExample request: GET /cloudapi/restapi/v3/user/status/12345",
                "operationId":"/v3/user/status/{jobId}_getCreateUsersStatus_1",
                "parameters":[
                    {
                        "name":"jobId",
                        "in":"path",
                        "description":"Job Id for which the status is being requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"12345"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"Create/Modify Users job has been successfully executed.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserDataStore"
                                }
                            }
                        }
                    },
                    "202":{
                        "description":"This Create/Modify Users job is currently in progress.",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserDataStore"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-status-{jobId}-get",
                "x-filename-id":"v3-user-status-jobid-get"
            }
        },
        "/v3/user/{userId}":{
            "get":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Get User",
                "description":"This operation fetches a user. All attributes and assigned roles for the user are returned.\n\nExample request: GET /cloudapi/restapi/v3/user/c8617ccb81aa481b174bb7b48debc38a\nExample request: GET /cloudapi/restapi/v3/user/jane.smith",
                "operationId":"/v3/user/{userId}_getUser_1",
                "parameters":[
                    {
                        "name":"userId",
                        "in":"path",
                        "description":"LoginId of the user being requested.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "examples":{
                            "User_Id":{
                                "summary":"User ID",
                                "description":"Internal user identifier.",
                                "value":"c8617ccb81aa481b174bb7b48debc38a"
                            },
                            "Login_Id":{
                                "summary":"Login ID",
                                "description":"User login identifier.",
                                "value":"jane.smith"
                            }
                        }
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "application/json":{
                                "schema":{
                                    "$ref":"#/components/schemas/UserRO"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    }
                },
                "x-internal-id":"v3-user-{userId}-get",
                "x-filename-id":"v3-user-userid-get"
            }
        },
        "/v3/user/{userId}/auto-reset-pwd":{
            "put":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Reset a User password (Random Value)",
                "description":"This operation generates a random string and writes it to the password field for the supplied {userId}. The user is notified when the operation completes successfully.\n\nExample request: PUT /cloudapi/restapi/v3/user/c8617ccb81aa481b174bb7b48debc38a/auto-reset-pwd",
                "operationId":"/v3/user/{userId}/auto-reset-pwd_resetPwdAndNotify_2",
                "parameters":[
                    {
                        "name":"userId",
                        "in":"path",
                        "description":"LoginId of the user for whom the password needs to be automatically reset.",
                        "required":true,
                        "schema":{
                            "type":"string"
                        },
                        "example":"c8617ccb81aa481b174bb7b48debc38a"
                    }
                ],
                "responses":{
                    "200":{
                        "description":"successful operation",
                        "content":{
                            "text/plain":{
                                "schema":{
                                    "type":"string"
                                }
                            }
                        }
                    },
                    "400":{
                        "description":"Invalid input, Please check."
                    },
                    "500":{
                        "description":"Internal Server Error. Underlying Identity Management System threw an error, Please check the logs."
                    }
                },
                "x-internal-id":"v3-user-{userId}-auto-reset-pwd-put",
                "x-filename-id":"v3-user-userid-auto-reset-pwd-put"
            }
        },
        "/v3/user/auto-reset-pwd":{
            "put":{
                "tags":[
                    "User Management (v3)"
                ],
                "summary":"Reset Users passwords (Random Value)",
[...]
